---
updatedAt: 2025-12-16T09:38:48.000Z
---

Fetch the complete documentation index at: https://apidocs.hibob.com/llms.txt. Use this file to discover all available pages before exploring further.

# Update Project

Update an existing project with the fields specified in the request body.
<p><b>Note</b>: The `/project/status` field cannot be updated via this endpoint. Use <a href="/reference/patch_attendance-projects-projectid-archive" target="_blank">archive</a>/<a href="/reference/patch_attendance-projects-projectid-restore" target="_blank">restore</a> endpoints instead.</p>
<p><b>Testing notes</b>:</p>
  <ul>
  <li>Use the testing widget's <b>Try It!</b> option to test this endpoint.</li>
  <li>Use the <b>Examples > Request Example</b> option to see how to initiate body parameters.</li>
  <li>For custom fields, use the <b>Examples > Request Example > Update project with fields</b> and copy to an external API client tool to change parameters.</li>
  </ul>


# OpenAPI definition

```json
{
  "openapi": "3.1.1",
  "info": {
    "title": "Attendance API",
    "contact": {
      "name": "Hi Bob, Inc."
    },
    "description": "Public API for importing attendance entries and managing attendance projects, tasks, and clients. Supports detailed field metadata and flexible filtering.",
    "license": {
      "name": "Proprietary",
      "url": "https://apidocs.hibob.com/docs/api-terms-of-use"
    },
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "https://api.hibob.com/v1",
      "description": "Production"
    },
    {
      "url": "https://api.sandbox.hibob.com/v1",
      "description": "Sandbox"
    }
  ],
  "x-readme": {
    "metrics-enabled": false
  },
  "tags": [
    {
      "name": "Projects",
      "description": "Operations for managing attendance projects, tasks and clients"
    }
  ],
  "paths": {
    "/attendance/projects/{projectId}": {
      "patch": {
        "operationId": "patch_attendance-projects-projectid",
        "tags": [
          "Projects"
        ],
        "summary": "Update Project",
        "description": "Update an existing project with the fields specified in the request body.\n<p><b>Note</b>: The `/project/status` field cannot be updated via this endpoint. Use <a href=\"/reference/patch_attendance-projects-projectid-archive\" target=\"_blank\">archive</a>/<a href=\"/reference/patch_attendance-projects-projectid-restore\" target=\"_blank\">restore</a> endpoints instead.</p>\n<p><b>Testing notes</b>:</p>\n  <ul>\n  <li>Use the testing widget's <b>Try It!</b> option to test this endpoint.</li>\n  <li>Use the <b>Examples > Request Example</b> option to see how to initiate body parameters.</li>\n  <li>For custom fields, use the <b>Examples > Request Example > Update project with fields</b> and copy to an external API client tool to change parameters.</li>\n  </ul>\n",
        "parameters": [
          {
            "name": "projectId",
            "in": "path",
            "required": true,
            "description": "The unique identifier of the project to update",
            "schema": {
              "type": "integer",
              "format": "int64",
              "example": 123456789
            }
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ProjectUpdateRequest",
                "default": {
                  "items": [
                    {
                      "objectType": "project",
                      "fields": {}
                    }
                  ]
                }
              },
              "examples": {
                "projectUpdateWithFields": {
                  "summary": "Update project with fields",
                  "value": {
                    "items": [
                      {
                        "objectType": "project",
                        "fields": {
                          "/project/name": {
                            "value": "Mobile App Redesign"
                          },
                          "/project/description": {
                            "value": "Complete redesign of mobile application UI/UX"
                          },
                          "/project/billable": {
                            "value": true
                          },
                          "/project/clientReference": {
                            "value": 42
                          },
                          "/project/audienceSelector": {
                            "value": {
                              "mode": "all"
                            }
                          },
                          "/project/field_726534": {
                            "value": "test custom field"
                          }
                        }
                      }
                    ]
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Project updated successfully"
          },
          "304": {
            "description": "Not modified"
          },
          "400": {
            "description": "The request is malformed or includes invalid parameters",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          },
          "401": {
            "description": "Authentication failed. Check your service user credentials",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          },
          "403": {
            "description": "The service user or token is missing the required permissions to access the requested data",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          },
          "404": {
            "description": "Project not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          },
          "429": {
            "description": "Rate limit exceeded - see <a href=\"https://apidocs.hibob.com/reference/projects#rate-limiting\">Rate limits</a>",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          },
          "500": {
            "description": "An unexpected error occurred. Try again or contact support if the issue persists.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorResponse"
                }
              }
            }
          }
        },
        "security": [
          {
            "basic": []
          },
          {
            "Bearer": []
          }
        ]
      }
    }
  },
  "components": {
    "securitySchemes": {
      "basic": {
        "type": "http",
        "scheme": "basic",
        "description": "Basic HTTP authentication using service user credentials"
      },
      "Bearer": {
        "type": "http",
        "scheme": "bearer",
        "bearerFormat": "OAuth 2.0",
        "description": "OAuth 2.0 authentication using an Access Token is available for registered partners only.  Try It! does not support the full HiBob OAuth flow. You can follow <a href=\"https://apidocs.hibob.com/reference/oauth-20#testing-from-the-public-api-reference\" target=\"_blank\">these steps</a> to complete the OAuth 2.0 flow in Postman and then paste the token here."
      }
    },
    "schemas": {
      "ApiErrorResponse": {
        "type": "object",
        "properties": {
          "key": {
            "type": "string",
            "description": "Error key identifier"
          },
          "error": {
            "type": "string",
            "description": "Human-readable error message"
          },
          "args": {
            "type": "array",
            "description": "Optional error arguments providing additional context",
            "items": {
              "type": "string"
            }
          }
        }
      },
      "ProjectUpdateRequestObject": {
        "type": "object",
        "description": "Request schema for updating projects.\n",
        "properties": {
          "objectType": {
            "type": "string",
            "enum": [
              "project"
            ],
            "description": "Type of the object"
          },
          "fields": {
            "type": "object",
            "default": {
              "type": "object"
            },
            "properties": {
              "/project/name": {
                "type": "object",
                "description": "The project name as provided by the user",
                "properties": {
                  "value": {
                    "type": "string"
                  }
                }
              },
              "/project/description": {
                "type": "object",
                "description": "The description of this project",
                "properties": {
                  "value": {
                    "type": "string"
                  }
                }
              },
              "/project/billable": {
                "type": "object",
                "description": "Whether this project is considered billable or not for tracking billing by project.",
                "properties": {
                  "value": {
                    "type": "boolean"
                  }
                }
              },
              "/project/clientReference": {
                "type": "object",
                "description": "This is a reference to a project client. Use the <a href=\"/reference/post_attendance-project-clients-search\" target=\"_blank\">project client search endpoint</a> to get the client ID.",
                "properties": {
                  "value": {
                    "type": "integer",
                    "format": "int64"
                  }
                }
              },
              "/project/audienceSelector": {
                "type": "object",
                "description": "Employees assigned to this project. Only assigned employees can log attendance entries for the project. Use `mode=all` to allow all employees or `mode=explicit` to specify employees in `employeeIds`. See <a href=\"/reference/post_people-search\" target=\"_blank\">Search for employees</a> to get the employee IDs.",
                "properties": {
                  "value": {
                    "type": "object",
                    "properties": {
                      "mode": {
                        "type": "string",
                        "enum": [
                          "all",
                          "explicit"
                        ]
                      },
                      "employeeIds": {
                        "type": "array",
                        "items": {
                          "type": "string"
                        }
                      }
                    }
                  }
                }
              },
              "/project/taskIds": {
                "type": "object",
                "description": "List of task IDs associated with the project. When `taskIds` is defined, time tracking operates at the task level, and billable behavior is determined by each task. Employees assigned to the project must select both a project and a task when logging attendance entries. Use the <a href=\"/reference/post_attendance-project-tasks-search\" target=\"_blank\">project task search endpoint</a> to get the task IDs.",
                "properties": {
                  "value": {
                    "type": "array",
                    "items": {
                      "type": "integer",
                      "format": "int64"
                    }
                  }
                }
              }
            },
            "description": "Project fields for update request (all optional)"
          }
        },
        "default": {
          "objectType": "project",
          "fields": {}
        },
        "required": [
          "objectType"
        ]
      },
      "ProjectUpdateRequest": {
        "type": "object",
        "description": "Request schema for updating projects",
        "properties": {
          "items": {
            "type": "array",
            "description": "List of projects to update (must contain exactly one item)",
            "minItems": 1,
            "maxItems": 1,
            "items": {
              "$ref": "#/components/schemas/ProjectUpdateRequestObject"
            }
          }
        },
        "required": [
          "items"
        ]
      }
    }
  }
}
```